# -*- coding: utf-8 -*-
"""
Created on Mon Jun 15 08:41:44 2015

@author: Zhou
"""
import PSR
import numpy as np
import LDStoPSR
from scipy.linalg import block_diag
import matplotlib.pyplot as plt
import BasicUtility as bu
import math

#This code is quite messy. I kept a lot of things just in case I would use them later. but I commented on the two functions that I used the most when diong the experiments.

def Arrange(n, m, p, filename):
    #here the parameters are of the same format as generate, different from prediction and learning
    #this function arranges the data from the csv file into matrices of the format we needed when doing the learning using least squares and covariance method
    data = []
    Obs = []
    oPs = []
    YPs = []
    training = bu.readCsv(filename)
    
    counter = 0
        
    for temp in training:
        counter = counter + 1
        O = temp[n]
        for s in range(n+1,len(temp)):
            O = np.concatenate((O, temp[s]), axis = 1)
        Obs.append(O)        
        for h in range(0, len(temp)-(n+1+p)):
            
            P = np.zeros((p*m, 1))
            for k in range(p):
                for s in range(m):
                    P[k*m+s, 0] = temp[h+k][s, 0]
            Y = np.zeros((n*m, 1))
            for k in range(n):
                for s in range(m):
                    Y[k*m+s, 0] = temp[h+p+k][s, 0]
            if counter == 1:
                oPs.append(temp[n+p+h] * np.transpose(P))
                YPs.append(Y * np.transpose(P))
            else:
                oPs[h] = oPs[h] + temp[n+p+h] * np.transpose(P)
                YPs[h] = YPs[h] + Y * np.transpose(P)
            
        matrix = np.zeros((n*m, len(temp)-n))
        for j in range(len(temp) - n):
            for s in range(n):
                for a in range(m):
                    matrix[s*m+a,j] = temp[j+s][a,0]
        data.append(matrix)
    
    oPfinal = np.zeros((m, p*m))
    YPfinal = np.zeros((n*m, p*m))
    for element in range(len(oPs)):        
        oPfinal = oPfinal + oPs[element]/(len(training))
        YPfinal = YPfinal + YPs[element]/(len(training))
    oPfinal = oPfinal/len(oPs)
    YPfinal = YPfinal/len(YPs)
    Os = [oPfinal, YPfinal, Obs]
    #print oPfinald
    #print YPfinal
    return (data, Os)
    
#I used this function to run most of the synthetic experiments. It just calls the the learning method with a number denoting which specific learning method to use     
def experiment(A, H, Q, R, x1, P, diagR, model, n, step):
    testfile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing3.csv'
    #testFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\trial1.csv'    
    test = bu.readCsv(testfile)  
    valiFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing2.csv'
    validation = bu.readCsv(valiFile)
    #n = A.shape[0]
    m = H.shape[0]
    x = np.transpose(np.matrix([x1]))
    Qprime = Q*np.transpose(Q)
    Rprime = R*np.transpose(R)
    diagRprime = diagR * np.transpose(diagR)
    mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A, H, Qprime, Rprime, x, P, diagRprime, n)
    print Sigma    
    print G
    print C
    print sigma
    """for parameter in (G, mu, Sigma, C, sigma):
        for i in range(parameter.shape[0]):
            for j in range(parameter.shape[1]):
                #if parameter[i, j] != 0:
                parameter[i, j] = parameter[i, j] + np.random.normal(0, 0.0000000000000000000000000000000000000001, None)"""
    zero = np.zeros(((n-1)*m, m))
    top = np.concatenate((zero,np.identity((n-1)*m)), axis = 1)
    Gprime = np.concatenate((top, G), axis = 0)
    Cprime = np.zeros((n*m, n*m))
    Cprime[:, (n-1)*m:n*m] = C
    SigmaDelta = np.zeros((n*m, n*m))
    SigmaDelta[(n-1)*m:n*m, (n-1)*m:n*m] = sigma
    """J = np.matrix(np.concatenate((np.identity(m), np.zeros((m, (n-1)*m))), axis=1)) 
    for i in range(10):
        print "new"
        print "G SIGMA G"
        GG = Gprime*Sigma*np.transpose(Gprime)
        print GG
        print "GC"
        GC = Gprime*Cprime
        print GC
        print "F"
        F = (Gprime*Sigma+np.transpose(Cprime))*np.transpose(J)
        print F
        print "F SIGMA F"
        FSF = F*np.linalg.pinv(J*Sigma*np.transpose(J))*np.transpose(F)
        print FSF
        Sigma =  GG + GC + np.transpose(GC) + SigmaDelta-FSF
        print "new sigma"
        print Sigma"""
    Tmean, variance, trueLil = bu.update(mu,Sigma, Gprime, Cprime, SigmaDelta, validation, m, n, step)
    print "True Model mean, variance, likehood: ", Tmean, ",", variance, ",", trueLil
    trend = [[], [], []]
    trendVar = [[], [], []]
    #likelihoodTrend = [[],[],[]]
    #likelihoodVar = [[],[],[]]
    #trend = [[]]
    #trendVar = [[]]
    for numSeq in range(1):
        numSeq = 1000
        #numSeq = 100
        print "#########################"
        print "experiment on number of sequences: ", numSeq
        print "#########################"
        sameSize = [[], [], []] # svd 0, LSQ 1, EM 2, LQwithOpt 3
        #sameSizelil = [[],[],[]]
        #sameSize = [[]]
        for fileNo in range(10):
            predictionError = [] 
            learntParams = []
            trainingfile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model + '\\shortSequence\\'+str(numSeq)+'\\'+str(numSeq)+'shortpsrtraining'+str(fileNo) + '.csv'
            data, Os = Arrange(n, m, n, trainingfile)
            
            """for reduced in range(1, n*m):
                params = PSR.learning(data, Os, m, n, 0, reduced)
                learntParams.append(params)
                mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n, step)
                print "covariance learning with SVD mean, variance, likelihood: ", mean, ",", variance, "," , likelihood, " SVD with dimension ", reduced
                predictionError.append(mean)
            params = PSR.learning(data, Os, m, n, 3, 0)
            learntParams.append(params)
            mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n, step)
            predictionError.append(mean)
            print "covariance learning mean, variance, likelihood: ", mean, ",", variance, ",", likelihood
            minError = np.inf
            #maxLikelihood = -np.inf
            selected = np.inf
            for i in range(len(predictionError)):
                #if predictionError[i] > maxLikelihood and predictionError[i] != 0:
                if predictionError[i] < minError:
                    selected = i
                    minError = predictionError[i]
            if selected is not np.inf:
                params = learntParams[selected]
                mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], validation, m, n, step)
                print selected
                print "selected mean, variance, likelihood: ", mean, ",", variance, ",", likelihood
                            
                sameSize[0].append(mean)
            else:
                sameSize[0].append(np.inf)
            muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 1, 0)
            mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, validation, m, n, step)
            print "least square learning mean, variance, likelihood: " , mean, ",", variance,  ",", likelihood
            sameSize[1].append(mean)"""
            EMmodelfile = 'C:\\Users\\Zhou\\Documents\\honours\\'+ model +'\\shortSequence\\'+str(numSeq)+'\\EMmodel' + str(fileNo) + 'd' + str(n)+'.csv'
            A, C, Q, R, x0, P0 = bu.readEM(EMmodelfile, n, m)
            if n == 5:
                diagR = block_diag(R, R, R, R, R)
            if n == 6:
                diagR = block_diag(R, R, R, R, R, R)
            if n == 7:
                diagR = block_diag(R, R, R, R, R, R, R)
            if n == 8:
                diagR = block_diag(R, R, R, R, R, R, R, R)
            if n == 9:
                diagR = block_diag(R, R, R, R, R, R, R, R, R)
            if n == 10:
                diagR = block_diag(R, R, R, R, R, R, R, R, R, R)
            if n == 11:
                diagR = block_diag(R, R, R, R, R, R, R, R, R, R, R)
            if n == 12:
                diagR = block_diag(R, R, R, R, R, R, R, R, R, R, R, R)
            if n == 13:
                diagR = block_diag(R, R, R, R, R, R, R, R, R, R, R, R, R)
            if n == 14:
                diagR = block_diag(R, R, R, R, R, R, R, R, R, R, R, R, R, R)
            muE, SigmaE, GE, CE, sigmaE = LDStoPSR.LDS2PSR(A, C, Q, R, x0, P0, diagR, n)
            print GE  
            print SigmaE
            zero = np.zeros(((n-1)*m, m))
            top = np.concatenate((zero,np.identity((n-1)*m)), axis = 1)
            GprimeE = np.concatenate((top, GE), axis = 0)
            CprimeE = np.zeros((n*m, n*m))
            CprimeE[:, (n-1)*m:n*m] = CE
            SigmaDeltaE = np.zeros((n*m, n*m))
            SigmaDeltaE[(n-1)*m:n*m, (n-1)*m:n*m] = sigmaE
            mean, variance, likelihood = bu.update(muE,SigmaE, GprimeE, CprimeE, SigmaDeltaE, validation, m, n, step)
            print "EM Learning mean, variance, likelihood: ", mean, ",", variance, ",", likelihood
            sameSize[2].append(mean)
            """minMean = np.inf
            minLambda = 0
            for Lambda in (1, 0.8, 0.5, 0.3, 0.1, 0.08, 0.05, 0.03,  0.01, 0.008, 0.005, 0.003, 0.001, 0.0008, 0.0005, 0.0003, 0.0001, 0.00008, 0.00005, 0.00003, 0.00001, 0.000008, 0.000005, 0.000003, 0.000001):
                #Lambda = float(Lambda1)/10000.0
                #for Lambda in (1, 0.1, 0.01, 0.001, 0.0001):         
                muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 4, Lambda)
                mean, variance = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, test, m, n)
                print "least square with sparsity learning mean, variance: " , mean, ",", variance, " with parameter ", Lambda
                if mean < minMean:
                    minMean = mean
                    minLambda = Lambda
            muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 4, minLambda)
            mean, variance = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, validation, m, n)
            print "least square with sparsity learning mean, variance: " , mean, ",", variance, " with parameter ", minLambda
            sameSize[0].append(mean)"""
            #params = PSR.learning(data, Os, m, n, 2, 0)
            #mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], validation, m, n, step)
            #print "least square with averaging learning mean, variance, likelihood: ", mean, ",", variance, ",", likelihood 
            #sameSizelil[3].append(likelihood)
        for method in range(len(sameSize)):
            noLikelihood = False
            for item in (sameSize[method]):
                if item == 0:
                    noLikelihood = True
            if noLikelihood:
                mean = np.inf
            else:
                mean = sum(sameSize[method])/len(sameSize[method])
            if mean < np.inf:
                variance = 0
                for i in range(len(sameSize[method])):
                    variance = variance + (sameSize[method][i] - mean)**2
                variance = variance/len(sameSize[method])
            else:
                variance = np.inf
            trend[method].append(mean)
            trendVar[method].append(np.sqrt(variance))
            print method
            print trend[method]
            print trendVar[method]
        
    xAxis = [10, 50, 100, 500, 1000, 5000, 10000]
    #yAxis = [trueLil, trueLil, trueLil, trueLil, trueLil]
    for method in range(len(trend)):
        plt.figure()
        plt.errorbar(xAxis, yAxis, xerr= 0 , yerr = 0)
        plt.errorbar(xAxis, trend[method], xerr = 0, yerr = trendVar[method])
        plt.xlabel('Number of Sequences')
        plt.ylabel('Mean Error')
        if method == 0:
            plt.title('Selected Covariance Method')
            plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\SelectedCovariancellh.jpg')
        if method == 1:
            plt.title('Least Square Method')
            plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\LeastSquarellh.jpg')
        if method == 2:
            plt.title('EM Method')
            plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\EMmethodllh.jpg')
        if method == 3:
            plt.title('Least Square with Average')
            plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\LQAvellh.jpg')
        """if method == 0:
            plt.title("Least Square with Sparsity")
            plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\LeastSquareSparse.jpg')"""
        
            
def partitionTest(mu, Sigma, G, sigma, C, datapoints, model, n, m):
    testfile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing0.csv'
    test = bu.readCsv(testfile)  
    valiFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing1.csv'
    validation = bu.readCsv(valiFile) 
    partMean = []
    partVar = []
    for num in (100, 500, 1000, 5000, 10000, 50000):
        lenSeq = datapoints/num
        sameSize = []
        for i in range(5):
            trainingfile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\partition\\' + str(num)+ '\\' + 'training' + str(i) + '.csv'
            bu.writeCsv(mu, Sigma, G, sigma, C, 2, lenSeq, num, trainingfile)
            predictionError = [] 
            learntParams = []
            data, Os = Arrange(n, m, n, trainingfile)
            for reduced in range(n, n*m):
                params = PSR.learning(data, Os, m, n, 0, reduced)
                learntParams.append(params)
                mean, variance = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n)
                print "covariance learning with SVD mean, variance: ", mean, ",", variance, " SVD with dimension ", reduced
                predictionError.append(mean)
            params = PSR.learning(data, Os, m, n, 3, 0)
            learntParams.append(params)
            mean, variance = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n)
            predictionError.append(mean)
            print "covariance learning mean, variance: ", mean, ",", variance
            minError = np.inf
            selected = np.inf
            for i in range(len(predictionError)):
                if predictionError[i] < minError:
                    selected = i
                    minError = predictionError[i]
            params = learntParams[selected]
            mean, variance = bu.update(params[0],params[4], params[1], params[2], params[3], validation, m, n)
            print selected
            print "selected mean and variance: ", mean, ",", variance
            sameSize.append(mean)
        mean = sum(sameSize)/len(sameSize)
        partMean.append(mean)
        variance = 0
        for i in range(len(sameSize)):
            variance = variance + (sameSize[i] - mean)**2
        partVar.append(np.sqrt(variance/len(sameSize)))
        print partMean
        print partVar
    xAxis = [100, 500, 1000, 5000, 10000, 50000]
    plt.errorbar(xAxis, partMean, xerr = 0, yerr = partVar)
    plt.xlabel('Number of Sequences')
    plt.ylabel('Prediction Error')
    plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\partition\\partition.jpg')
    
            
def dataSet(mu, Sigma, G, sigma, C, dimension, model):
    for num in (10, 30):
        print 'the number of sequences we are writing is ', num, '....'
        for i in range(5):
            filename = 'C:\\Users\\Zhou\\Documents\\honours\\'+model+'\\shortSequence\\'+str(num)+'\\' + str(num) + 'shortpsrtraining' + str(i)+'.csv'
            bu.writeCsv(mu, Sigma, G, sigma, C, dimension, 30, num, filename)
            #filename = 'C:\\Users\\Zhou\\Documents\\honours\\'+model+'\\testSet\\testing'+str(i)+'.csv'
            #bu.writeCsv(mu, Sigma, G, sigma, C, dimension, 100, 1000, filename)

def sparseVsNonsparse(A, H, Q, R, x1, P, diagR, model):
    testFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing2.csv'
    valiFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing3.csv'
    validation = bu.readCsv(valiFile)
    test = bu.readCsv(testFile)
    n = A.shape[0]
    m = H.shape[0]
    x = np.transpose(np.matrix([x1]))
    Qprime = Q*np.transpose(Q)
    Rprime = R*np.transpose(R)
    diagRprime = diagR * np.transpose(diagR)
    mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A, H, Qprime, Rprime, x, P, diagRprime, n)
    for i in range(G.shape[0]):
        print G[i, :]
    zero = np.zeros(((n-1)*m, m))
    top = np.concatenate((zero,np.identity((n-1)*m)), axis = 1)
    Gprime = np.concatenate((top, G), axis = 0)
    Cprime = np.zeros((n*m, n*m))
    Cprime[:, (n-1)*m:n*m] = C
    SigmaDelta = np.zeros((n*m, n*m))
    SigmaDelta[(n-1)*m:n*m, (n-1)*m:n*m] = sigma 
    #Tmean, variance, likelihood = bu.update(mu,Sigma, Gprime, Cprime, SigmaDelta, test, m, n, 1)
    #print "True Model mean, variance: ", Tmean, ",", variance 
    trend = [[],[]]
    trendVar = [[],[]]
    for num in (5000, 10000):
    
        print "sample size ", num
        best = [[],[]]
        for i in range(10):
            trainingfile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model + '\\shortSequence\\' + str(num) + '\\' + str(num) + 'shortpsrtraining'+ str(i) + '.csv'
            data, Os = Arrange(n, m, n, trainingfile)             
               
            minMean = np.inf
            predictions = []
            params = []
            minLambda = np.inf
            for k in (4.0, 4.5, 5.0, 5.5, 6.0, 6.5, 7.0, 7.5, 8.0, 8.5, 9.0, 9.5, 10.0, 10.5, 11.0):
                Lambda = math.pow(2.0, -k)
                muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 4, Lambda)
                mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, validation, m, n, 1)
                print "least square with sparsity learning mean, variance: " , mean, ",", variance, " with parameter ", Lambda
                predictions.append(mean)        
                if mean < minMean:
                    minMean = mean
                    minLambda = Lambda
                    params = [muL, GprimeL, CL, SigmaDeltaL, SigmaL]
            #muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 4, minLambda)
            print params[1][(n-1)*m:, :]
            mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n, 1)
            best[0].append(mean)
            #print minLambda
            print "least square with sparsity learning mean, variance, likelihood: " , mean, ",", variance, ",", likelihood
            muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 1, 0)
            print GprimeL[(n-1)*m:, :]
            mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, test, m, n, 1)
            print "least square without sparsity learning mean, variance, likelihood: " , mean, ",", variance, ",", likelihood
            best[1].append(mean)
            """predictionError = [] 
            learntParams = []
            for reduced in range(1, n*m):
                params = PSR.learning(data, Os, m, n, 0, reduced)
                learntParams.append(params)
                mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n, 1)
                print "covariance learning with SVD mean, variance, likelihood: ", mean, ",", variance, "," , likelihood, " SVD with dimension ", reduced
                predictionError.append(mean)
            params = PSR.learning(data, Os, m, n, 3, 0)
            learntParams.append(params)
            mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], test, m, n, 1)
            predictionError.append(mean)
            print "covariance learning mean, variance, likelihood: ", mean, ",", variance, ",", likelihood
            minError = np.inf
            #maxLikelihood = -np.inf
            selected = np.inf
            for i in range(len(predictionError)):
                #if predictionError[i] > maxLikelihood and predictionError[i] != 0:
                if predictionError[i] < minError:
                    selected = i
                    minError = predictionError[i]
            if selected is not np.inf:
                params = learntParams[selected]
                mean, variance, likelihood = bu.update(params[0],params[4], params[1], params[2], params[3], validation, m, n, 1)
                print selected
                print "selected mean, variance, likelihood: ", mean, ",", variance, ",", likelihood
                            
                best[2].append(mean)
            else:
                best[2].append(np.inf)"""
        for method in range(len(trend)):
            mean = sum(best[method])/len(best[method])
            trend[method].append(mean)
            var = 0
            for item in best[method]:
                var = var + (item - mean)**2
            trendVar[method].append(var/len(best[method]))
        print trend 
        print trendVar
        
# This function was the one i used to test the method that learns the sparse G    
def testLasso(A, H, Q, R, x1, P, diagR, model):
    testFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing0.csv'
    valiFile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model+'\\testSet\\testing1.csv'
    validation = bu.readCsv(valiFile)
    test = bu.readCsv(testFile)
    n = A.shape[0]
    m = H.shape[0]
    """print n
    print m"""
    x = np.transpose(np.matrix([x1]))
    Qprime = Q*np.transpose(Q)
    Rprime = R*np.transpose(R)
    diagRprime = diagR * np.transpose(diagR)
    mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A, H, Qprime, Rprime, x, P, diagRprime, n)
    print mu
    print Sigma
    print G
    print C
    print sigma 
    zero = np.zeros(((n-1)*m, m))
    top = np.concatenate((zero,np.identity((n-1)*m)), axis = 1)
    Gprime = np.concatenate((top, G), axis = 0)
    Cprime = np.zeros((n*m, n*m))
    Cprime[:, (n-1)*m:n*m] = C
    SigmaDelta = np.zeros((n*m, n*m))
    SigmaDelta[(n-1)*m:n*m, (n-1)*m:n*m] = sigma
    Tmean, variance, likelihood = bu.update(mu,Sigma, Gprime, Cprime, SigmaDelta, test, m, n, 1)
    print "True Model mean, variance: ", Tmean, ",", variance    
    
    trainingfile = 'C:\\Users\\Zhou\\Documents\\honours\\' + model + '\\shortSequence\\100\\100shortpsrtraining4.csv'
    data, Os = Arrange(n, m, n, trainingfile)   
    muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 6, 0)
    #print "Least Square with imposed sparsity patter: " 
    
    #print GprimeL
    
    mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, validation, m, n, 1)
    print "least square with sparsity learning mean, variance, likelihood: " , mean, ",", variance, ",", likelihood
    muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 1, 0)
    #print "Least Square: " 
    
    #print GprimeL
    mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, validation, m, n, 1)
    print "least square without sparsity learning mean, variance, likelihood: " , mean, ",", variance, ",", likelihood
        
    minMean = np.inf
    minLambda = 0
    Lambda = 1
    Lambdas = []
    predictions = []
    #for k in range(700, 780, 1):
    for k in range(15):
        #Lambda = float(k)/10000.0
        #Lambda = math.pow(2, -float(k)/100.0)
        Lambda = math.pow(2.0, -k)
        Lambdas.append(k)
        #Lambda = float(Lambda1)/10000.0
        #for Lambda in (1, 0.1, 0.01, 0.001, 0.0001):         
        muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 4, Lambda)
        #print GprimeL
        mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, test, m, n, 1)
        print "least square with sparsity learning mean, variance: " , mean, ",", variance, " with parameter ", Lambda
        predictions.append(mean)        
        if mean < minMean:
            minMean = mean
            minLambda = Lambda
        #k = k + 0.1
    muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, 4, minLambda)
    #print GprimeL
    mean, variance, likelihood = bu.update(muL,SigmaL, GprimeL, CL, SigmaDeltaL, validation, m, n, 1)
    print "least square with sparsity learning mean, variance: " , mean, ",", variance, " with parameter ", minLambda
    """plt.figure()
    plt.plot(Lambdas, predictions, label = 'Different Param')
    plt.xlabel('Parameter Alpha')
    plt.ylabel('Mean Error')
    plt.savefig('C:\\Users\\Zhou\\Documents\\honours\\noisyBasicModel\\shortSequence\\50ParamSelectionlog.jpg')
    print Lambdas
    print predictions"""


def PredictionDemo(n, mu, Sigma, G, sigma, C, m,  predLength, method):
    """here the parameters are the ones you used to generate data
    n is the No. of observations, m is the dimention of an observation
    k is the number of sequences"""
    J = np.concatenate((np.identity(m), np.zeros((m, (n-1)*m))), axis=1)
    trainingfile =  'C:\\Users\\Zhou\\Documents\\honours\\basicModel\\shortSequence\\3000\\3000shortpsrtraining1.csv'
    data, Os = Arrange(n, m, n, trainingfile)
    muL, GprimeL, CL, SigmaDeltaL, SigmaL = PSR.learning(data, Os, m, n, method, 0)
    """print muL
    print GprimeL
    print CL
    print SigmaDeltaL
    print SigmaL
    GppL = GprimeL[(n-1)*m:, :]
    CppL = CL[:, (n-1)*m:]
    SigmaDeltappL = SigmaDeltaL[(n-1)*m:, (n-1)*m:]"""
    #print generate(mu, Sigma, G, sigma, C, m, predLength)[0]
    
    """temp = PSR.generate(mu, Sigma, G, sigma, C, m, predLength)[0]
    for parameter in (G, mu, Sigma, sigma, C):
        for i in range(parameter.shape[0]):
            for j in range(parameter.shape[1]):
                #if parameter[i, j] != 0:
                parameter[i, j] = parameter[i, j] + np.random.normal(0, 0.01, None)
    print mu
    print Sigma
    print G
    print C
    print sigma
    
    SigmaL = Sigma
    zero = np.zeros(((n-1)*m, m))
    top = np.concatenate((zero,np.identity((n-1)*m)), axis = 1)
    Gprime = np.concatenate((top, G), axis = 0)
    Cprime = np.zeros((n*m, n*m))
    Cprime[:, (n-1)*m:n*m] = C
    #print Cprime
    SigmaDelta = np.zeros((n*m, n*m))
    SigmaDelta[(n-1)*m:n*m, (n-1)*m:n*m] = sigma
    #temp = training[45]
    Ypred = []
    difference = 0
    for i in range(len(temp)):
        
        pred = np.dot(J, mu)
        Ypred.append(pred)
        print "prediction"
        print Ypred[i]
        print "observation"
        print temp[i]
        distance = np.linalg.norm(pred - temp[i])
        #print "difference"
        difference = difference + distance
        #print distance
        if distance > 10:
            #print "************************************"
        #print "Sigma"
        #print SigmaL
        if distance > 10:
            print "************************************"
        print "##############
        mu, SigmaL = PSR.prediction(mu, Gprime, Cprime, SigmaDelta, SigmaL, m, n, temp[i], Sigma)
    print difference/len(temp)
    return Ypred"""
        
def test():
    A = []
    H = []
    Q = []
    R = []
    x1 = []
    P = []
    diagR = []
    model = ['basicModel', 'model1', 'model2', 'stableModel', '1dModel', 'BiggerDimension', 'debug', 'SparseModel'] 
    """mu = np.matrix([[1], [2], [3], [4]])
    G = np.matrix([[0.1, 0.2, 0.3, 0.4]])
    sigma = np.matrix([[0.3]])
    C = np.matrix([[0.1], [0.1], [0.2], [0.15]])
    Sigma = np.matrix([[0.5, 0.1, 0.09, 0.09], [0.8, 0.5, 0.07, 0.09], [0.1, 0.09, 0.5, 0.08], [0.09, 0.08, 0.09, 0.5]])"""
    #######  BASIC MODEL ########
    A.append(np.matrix([[1, 0, 1, 0], [0, 1, 0, 1], [0, 0, 1, 0], [0, 0, 0, 1]]))
    H.append(np.matrix([[1, 0, 0, 0], [0, 1, 0, 0]]))
    Q.append(np.matrix([[0.01, 0, 0, 0],[0, 0.01, 0, 0], [0, 0, 0.01, 0], [0, 0, 0, 0.01]]))
    R.append(np.matrix([[0.01, 0], [0, 0.01]]))
    #Q.append(np.matrix([[0.3, 0, 0, 0],[0, 0.3, 0, 0], [0, 0, 0.3, 0], [0, 0, 0, 0.3]]))
    #R.append(np.matrix([[0.3, 0], [0, 0.3]]))
    diagR.append( block_diag(R[0], R[0], R[0], R[0]))
    x1.append([2, 1, 0.2, 0.2])
    P.append(np.matrix([[0.1, 0, 0, 0],[0, 0.1, 0, 0],[0, 0, 0.1, 0],[0, 0, 0, 0.1]]))
    #######   MODEL 1   #########
    A.append(np.matrix([[1, 0, 1, 0], [0, 1, 0, 1], [0, 0, 1, 0], [0, 0, 0, 1]]))
    H.append(np.matrix([[1, 0, 0.5, 0], [0, 1, 0, 0.5]]))
    #Q.append(np.matrix([[0.1, 0。01, 0.01, 0.01],[0.01, 0.1, 0.01, 0.01], [0.01, 0.01, 0.1, 0.01], [0.01, 0.01, 0.01, 0.1]]))
    #R.append(np.matrix([[0.1, 0.01], [0.01, 0.1]]))
    Q.append(np.matrix([[0.1, 0, 0, 0],[0, 0.1, 0.01, 0.01], [0.01, 0.01, 0.1, 0.01], [0.01, 0.01, 0.01, 0.1]]))
    R.append(np.matrix([[0.1, 0.01], [0.01, 0.1]]))
    diagR.append(block_diag(R[1], R[1], R[1], R[1]))
    x1.append([2, 1, 0.2, 0.2])
    P.append(np.matrix([[1, 0.1, 0.1, 0.1],[0.1, 0.01, 0.1, 0.1],[0.1, 0.1, 1, 0.1],[0.1, 0.1, 0.1, 1]]))
    ########   MODEL 2  ###########
    A.append(np.matrix([[0.8, 0, 1.1, 0], [0, 0.3, 0, 0.7], [0, 0, 0.2, 0], [0, 0, 0, 1]]))
    H.append(np.matrix([[1.1, 0, 0.5, 0], [0, 1.5, 0, 0.5]]))
    Q.append(np.matrix([[0.1, 0.01, 0.01, 0.01],[0.01, 0.1, 0.01, 0.01], [0.01, 0.01, 0.1, 0.01], [0.01, 0.01, 0.01, 0.1]]))
    R.append(np.matrix([[0.1, 0.01], [0.01, 0.1]]))
    #Q.append(np.matrix([[0.1, 0, 0, 0],[0, 0.1, 0, 0], [0, 0, 0.1, 0], [0, 0, 0, 0.1]]))
    #R.append(np.matrix([[0.1, 0], [0, 0.1]]))
    diagR.append(block_diag(R[2], R[2], R[2], R[2]))
    x1.append([2, 1, 0.2, 0.2])
    P.append(np.matrix([[1, 0.1, 0.1, 0.1],[0.1, 0.01, 0.1, 0.1],[0.1, 0.1, 1, 0.1],[0.1, 0.1, 0.1, 1]]))
    ######## Stable Model ##########
    A.append(np.matrix([[0.8, 0, 0.98, 0], [0, 0.3, 0, 0.7], [0, 0, 0.2, 0], [0, 0, 0, 0.9]]))
    H.append(np.matrix([[1.1, 0, 0.5, 0], [0, 1.5, 0, 0.5]]))
    Q.append(np.matrix([[0.1, 0.01, 0.01, 0.01],[0.01, 0.1, 0.01, 0.01], [0.01, 0.01, 0.1, 0.01], [0.01, 0.01, 0.01, 0.1]]))
    R.append(np.matrix([[0.1, 0.01], [0.01, 0.1]]))
    diagR.append(block_diag(R[0], R[0], R[0], R[0]))
    x1.append([2, 1, 0.2, 0.2])
    P.append(np.matrix([[1, 0.1, 0.1, 0.1],[0.1, 0.01, 0.1, 0.1],[0.1, 0.1, 1, 0.1],[0.1, 0.1, 0.1, 1]]))        
    #A = np.matrix([[0.7, 0],[0, 0.9]])
    #H = np.matrix([[1.1, -0.5], [0.2, 0.7]])
    #P = np.matrix([[0.1, 0],[0, 0.1]])
    #Q = np.matrix([[0.09, 0],[0, 0.09]])
    #R = np.matrix([[0.11, 0],[0, 0.11]])
    #x1 = [0,0]
    #print YGenerator(x1, A, H, Q, R, P, 100)
    ######### One dimensional Model##########
    A.append(np.matrix([[1, 1], [0, 1]]))
    H.append(np.matrix([[1, 0]]))
    #Q.append(np.matrix([[0.01, 0], [0, 0.01]]))
    #R.append(np.matrix([[0.01]]))
    #diagR.append(0.01*np.identity(2))
    Q.append(np.matrix([[0.3, 0], [0, 0.3]]))
    R.append(np.matrix([[0.3]]))
    diagR.append(0.3*np.identity(2))
    x1.append([0.1, 0.5])
    P.append(np.matrix([[0.1, 0], [0, 0.1]]))
    ######### Higher Dimension Model########
    A.append(np.matrix([[1, 0, 0, 1, 0, 0],[0, 1, 0, 0, 1, 0],[0, 0, 1, 0, 0, 1],[0, 0, 0, 1, 0, 0],[0, 0, 0, 0, 1, 0],[0, 0, 0, 0, 0, 1]]))
    H.append(np.matrix([[1, 0, 0, 0, 0, 0],[0, 1, 0, 0, 0, 0],[0, 0, 1, 0, 0, 0]]))
    Q.append(0.3*np.eye(6))
    R.append(0.3*np.eye(3))
    diagR.append(0.3*np.eye(18))    
    #Q.append(0.1*np.eye(6))
    #R.append(0.1*np.eye(3))
    #diagR.append(0.1*np.eye(18))
    x1.append([0.3, -0.1, 0.4, 0.02, 0.01, -0.04])
    P.append(0.1*np.eye(6))
    ########## debugging model ###########
    A.append(np.matrix([[1, 0, 1, 0], [0, 1, 0, 1], [0, 0, 1, 0], [0, 0, 0, 1]]))
    H.append(np.matrix([[1, 0, 0, 0], [0, 1, 0, 0]]))
    Q.append(np.matrix([[0.3, 0, 0, 0],[0, 0.3, 0, 0], [0, 0, 0.3, 0], [0, 0, 0, 0.3]]))
    R.append(np.matrix([[0.3, 0], [0, 0.3]]))
    diagR.append( 0.3 * np.eye(8))
    x1.append([2, 1, 0.2, 0.2])
    P.append(np.matrix([[0, 0, 0, 0],[0, 0, 0, 0],[0, 0, 0, 0],[0, 0, 0, 0]]))
    #print YGenerator(x1, A, H, Q, R, P, 100)
    ######### Sparse Model ############
    A.append(np.matrix(block_diag(A[0], A[0], A[0], A[0])))
    H.append(np.matrix(block_diag(H[0], H[0], H[0], H[0])))
    Q.append(0.1*np.eye(16))
    R.append(0.1*np.eye(8))
    diagR.append(0.1*np.eye(128))
    x1.append([2, 1, 0.2, 0.2, 2, 1, 0.2, 0.2, 2, 1, 0.2, 0.2, 2, 1, 0.2, 0.2])
    P.append(0.1*np.eye(16))    
    for j in range(1):
        i = 4
        Qprime = Q[i]*np.transpose(Q[i])
        Rprime = R[i]*np.transpose(R[i])
        diagRprime = diagR[i]*np.transpose(diagR[i])
        x = np.transpose(np.matrix([x1[i]]))
        #seq = []
        #filename = 'C:\\Users\\Zhou\\Documents\\honours\\debug\\trial.csv'
        #bu.writeCsv(x1[i], A[i], H[i], Q[i], R[i], P[i], 2, 50, 1000, filename)
        #print PSR.YGenerator (x1[i], A[i], H[i], Q[i], R[i], P[i], 50)
        mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A[i], H[i], Qprime, Rprime, x, P[i], diagRprime, A[i].shape[0])  
        #print PSR.generate(mu, Sigma, G, sigma, C, 2, 50)[0]     
        #mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A[i], H[i], Qprime, Rprime, x, P[i], diagRprime, A[i].shape[0])
        dataSet(mu, Sigma, G, sigma, C, H[i].shape[0], "noisy1dModel")
    #mdl = -3
    #print model[mdl]
    #experiment(A[mdl], H[mdl], Q[mdl], R[mdl], x1[mdl], P[mdl], diagR[mdl], model[mdl], 6, 1)
    #testLasso(A[mdl], H[mdl], Q[mdl], R[mdl], x1[mdl], P[mdl], diagR[mdl], model[mdl])
    #sparseVsNonsparse(A[mdl], H[mdl], Q[mdl], R[mdl], x1[mdl], P[mdl], diagR[mdl], model[mdl])
    #mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A[-4], H[-4], Q[-4], Rprime, x, P[0], diagRprime, A[0].shape[0])
    #bu.writeCsv(mu, Sigma, G, sigma, C, 2, 100, 100)
    #generated = generate(mu, Sigma, G, sigma, C, 2, 50)[0]
    #result = syntheticExp(4, mu, Sigma, G, sigma, C, 2, 100, 100)
    """Qprime = Q[0]*np.transpose(Q[0])
    Rprime = R[0]*np.transpose(R[0])
    diagRprime = diagR[0]*np.transpose(diagR[0])
    x = np.transpose(np.matrix([x1[0]]))
    mu,Sigma, G, C, sigma  = LDStoPSR.LDS2PSR(A[0], H[0], Qprime, Rprime, x, P[0], diagRprime, A[0].shape[0])"""
    #partitionTest(mu, Sigma, G, sigma, C, 100000, 'basicModel', 4, 2)
    #PredictionDemo(4, mu, Sigma, G, sigma, C, 2, 100, 4)
    
if __name__ == '__main__':
    test()

